(* send a file to mai 2000 *)

// I have connected the MAI 2000 Serial ports to
// a Terminalserver, therefore i connect using
// TCP/IP

{$longstrings on}
{$mode objfpc}

unit send2000;

interface

uses ssockets,sysutils;

const
  DefIP = '192.168.253.20';
  DefPort = 5004;  // This is tty6
  BufLen = 32;

function SendIt (ftype:char; const fn,host : string; PortNum : word; RemoteFileName : string) : boolean;

implementation

var Stream : TSocketStream = nil;


function SendIt (ftype:char; const fn,host : string; PortNum : word; RemoteFileName : string) : boolean;
var

  t : text;
  f : file;
  res : char;
  s,s1 : string;
  rest,len:integer;
  c : char;
  reclen,keylen:word;
  numrecs,i,j : longint;

  procedure ShowProcess;
  begin
    case c of
      '|' : c := '/';
      '/' : c := '-';
      '-' : c := '\';
      '\' : c := '|';
    end;
    write (c,#8);
  end;

  function SendArg (value,desc : string; CR:Boolean):boolean;
  begin
    if CR then Value := Value +#13;
    Stream.Write (value[1],length(value));
    Stream.Read(res,1);
    if res <> '1' then
    begin
      writeln ('Got false for '+Desc+' command');
      result := false;
    end else
      result := true;
  end;

  function sendRec (value,desc : string):boolean;
  var len : longint;
  begin
    result := sendArg (IntToStr(Length(Value)),'Rec Length',true);
    //writeln('Len: ',Length(Value));
    if not result then exit;
    if length(Value) = 0 then exit;
    while length(Value) > 0 do
    begin
      Len := Length(Value);
      if Len > BufLen then Len := BufLen;
      result := sendArg (Copy(Value,1,Len),'Record Data',false);
      if not result then exit;
      Value := Copy (Value,Len+1,length(Value));
    end;
  end;

begin
  if (c = 'P') then
  begin
    assign (T,fn); reset (t);
  end else
  begin
    assign(f,fn); reset(f,1);
  end;
  if stream = nil then Stream := TInetSocket.Create(Host,PortNum);
  try
    c:='R';
    Stream.Write (c,1);   // Receive
    repeat
      Stream.Read(res,1);
      //write (res);
    until (res = '0') or (res = '1');
   if res <> '1' then
   begin
      writeln ('Got false for Receive command');
      exit;
    end;

    c := ftype;
    Stream.Write (c,1);   // Program/Indexed/...
    Stream.Read(res,1);
    if res <> '1' then
    begin
      writeln ('Got false for FileType command ('+c+')');
      exit;
    end;

    // send filename
    if not SendArg (remoteFilename,'filename',true) then exit;

    c := '|';

    case ftype of
      'P':
        begin
          while not eof(t) do
          begin
            readln (t,s);
            ShowProcess;

            if not SendArg (IntToStr(Length(s)),'Line len',true) then exit;

            rest := length(s);
            while (rest > 0) do
            begin
              len := rest; if len > buflen then len := buflen;
              dec(rest,len);

              Stream.Write (S[1],len);
              delete(s,1,len);
              Stream.Read(res,1);
              if res <> '1' then
              begin
                writeln ('Got false for Send Line command');
                exit;
              end;
            end;
          end;
          close(t);
        end;
      'I' :
        begin
          BlockRead(f,reclen,sizeof(reclen));
          BlockRead(f,numrecs,sizeof(numrecs));
          if not SendArg (IntToStr(reclen),'reclen',true) then exit;
          if not SendArg (IntToStr(numrecs),'numrecs',true) then exit;

          for i := 1 to numrecs do
          begin
            ShowProcess;
            setlength(s,reclen);
            blockread(f,s[1],reclen);
            while(length(s) > 0) and (s[length(s)] = #0) do
              s := copy (s,1,length(s)-1);
            s1 := '';
            for j :=1 to length(s) do
              s1 := s1 + IntToHex(byte(s[j]),2);
            s1 := AnsiUpperCase(s1);
            if not SendRec (s1,'Record') then exit;
          end;
          close(f);
        end;
    end;
    s := '-1'+#13;
    Stream.Write (S[1],length(s));
    write('Saving');
    Stream.Read(res,1);
    write(#8#8#8#8#8#8,'      ',#8#8#8#8#8#8);
    if res <> '0' then
    begin
      writeln ('Got no false for Last Line command');
      exit;
    end;
  finally

  end;

end;

{begin
  sendIt ('00DAT\!1.bbm',DefIP,DefPort);}
initialization
finalization
  if stream <> nil then stream.free;
end.
